.include "appnotes\tn2313def.inc"

.def Temp1=R16
.def Temp2=R17
.def Chsec=R18 ;
.def Presskey=R19 ; 
.def Ddp=R20 ;

.dseg
Digit: .byte 4

.cseg
.org 0

rjmp Reset
rjmp INT_0
rjmp INT_1
rjmp Timer1_capt1
rjmp Timer1_comp1
rjmp Timer1_OVF1
rjmp Timer0_OVF0
rjmp UART_RX
rjmp UART_UDRE
rjmp UART_TX
rjmp ANA_COMP

;Reset: ;  
INT_0:
INT_1:
Timer1_capt1:
;Timer1_comp1: ;
Timer1_OVF1:
Timer0_OVF0:
UART_RX:
UART_UDRE:
UART_TX:
ANA_COMP:
reti
;****************************************************************************
Reset:

ldi Temp1,RamEnd
out SPL,Temp1 ;  

ldi Temp1,0b11111111
out ddrb, Temp1 ;   b

ldi Temp1,0b01101100
out ddrd, Temp1 ;   d

ldi Temp1,0b01000000
out Timsk,Temp1 ;  

ldi Temp1,0b00000100
out Tccr1b,Temp1 ;  /256

ldi Temp1,0x3d
out Ocr1ah,Temp1
ldi Temp1,0x09
out Ocr1al,Temp1 ;   15625 (0.4.  10)

ldi Temp1,0 ;   
sts Digit,Temp1
sts Digit+1,Temp1
sts Digit+2,Temp1
sts Digit+3,Temp1

ldi Chsec,0;   

ldi Presskey,0 ;   

ldi Ddp,0 ; 

ldi Temp1,0
out Tcnt1h,Temp1
out Tcnt1l,Temp1 ; 

sei ;   


;********************  *********************************************************

Cycle:
rcall Display
rcall Press
rjmp Cycle
;******************************************
Display:

ldi Temp1, 0b00101100
out PortD,Temp1
lds Temp1,Digit
rcall Decoder
out PortB,Temp1
rcall Delay ;  1-  (.)

ldi Temp1, 0b01001100
out PortD,Temp1
lds Temp1,Digit+1
rcall Decoder
out PortB,Temp1
rcall Delay ;  2- 

ldi Temp1, 0b01100100
out PortD,Temp1
lds Temp1,Digit+2
rcall Decoder
andi Ddp,0b00000001 ;  
cpi Ddp,1 ; 
breq Indicout ;     
ldi Temp2,0b00100000
add Temp1,Temp2 ;  h 
Indicout: out PortB,Temp1
rcall Delay ;  3- 

ldi Temp1, 0b01101000
out PortD,Temp1
lds Temp1,Digit+3
rcall Decoder
out PortB,Temp1
rcall Delay ;  4- 

ret

;****************************************************************************

;********************************************
Decoder:

ldi ZL,Low(Matrix*2)
ldi ZH,High(Matrix*2)
ldi Temp2,0
add ZL,Temp1
adc ZH,Temp2
lpm
mov Temp1,r0

ret
;**********************************************************

;****************************************************
Matrix:
;     edhcgafb   edhcgafb
.db 0b11010111,0b00010001 ;01
.db 0b11001101,0b01011101 ;23
.db 0b00011011,0b01011110 ;45
.db 0b11011110,0b00010101 ;67
.db 0b11011111,0b01011111 ;89
;**********************************************************

;**************************************************
Delay:
ldi Temp1,0
ldi Temp2,5
dll: dec Temp1
brne dll
dec Temp2
brne dll
ret
;**********************************************************

;*************** **********************
Timer1_comp1:

ldi Temp1,0
out Tcnt1h,Temp1
out Tcnt1l,Temp1 ; 

inc Ddp ;  

inc Chsec ;  
cpi Chsec,150 ;  150*0.4c=60c=1
brne Output2 ;     

;================================

ldi Chsec,0 ;   

;================================

lds Temp1,Digit ;  1- 
inc Temp1 ; 1- 

cpi Temp1,10 ;
breq Test2 ;   2

sts Digit,Temp1 ;  1- 
rjmp Output2 ; 2

;=================================

Test2:

ldi Temp1,0 ;   
sts Digit,Temp1 ;  1- 

lds Temp1,Digit+1 ;  2- 
inc Temp1 ; 2- 

cpi Temp1,6 ;
breq Test3 ;   3

sts Digit+1,Temp1 ;  2- 
rjmp Output2 ; 2


;=================================

Test3:

ldi Temp1,0 ;   
sts Digit+1,Temp1 ;  2- 

lds Temp1,Digit+2 ;  3- 
inc Temp1 ; 3- 

cpi Temp1,10 ;
breq Test4 ;   4

sts Digit+2,Temp1 ;  3- 
rjmp Output1 ; 1

;=================================

Test4:

ldi Temp1,0 ;   
sts Digit+2,Temp1 ;  3- 

lds Temp1,Digit+3 ;  4- 
inc Temp1 ; 4- 

sts Digit+3,Temp1 ;  4- 
rjmp Output1 ;  1

;=================================

Output1:

lds Temp1,Digit+3 ; 4- 
cpi Temp1,2 ; 
brne Output2 ;   

lds Temp1,Digit+2 ; 4- 
cpi Temp1,4 ; 
brne Output2 ;   

ldi Temp1,0
sts Digit+2,Temp1
sts Digit+3,Temp1 ; 3-  4- 

Output2:
reti
;**********************************************************

;************************** **************
Press:
in Temp1,PinD ;   d
andi Temp1,0b00000011 ;   
cpi Temp1,0b00000011 ;
breq Nobut ;   ( )  

;===================================

cpi Temp1,0b00000010
brne Press_hour ;       . 

sub Temp1,Presskey ; 
breq Outpress ;  ,      
ldi Presskey,0b00000010 ;   


lds Temp1,Digit ;  1- 
inc Temp1 ; 1- 

cpi Temp1,10 ;
breq Tst2 ;   2

sts Digit,Temp1 ;  1- 
rjmp Outpress ; 

;=================================

Tst2:

ldi Temp1,0 ;   
sts Digit,Temp1 ;  1- 

lds Temp1,Digit+1 ;  2- 
inc Temp1 ; 2- 

cpi Temp1,6 ;
breq Tst3 ;   3

sts Digit+1,Temp1 ;  2- 
rjmp Outpress ; 

;=================================

Tst3:
ldi Temp1,0 ;   
sts Digit+1,Temp1 ;  2- 
rjmp Outpress ; 
;******************
Press_hour:

sub Temp1,Presskey ; 
breq Outpress ;  ,      
ldi Presskey,0b00000001 ;   

lds Temp1,Digit+2 ;  3- 
inc Temp1 ; 3- 
cpi Temp1,10 ;
breq Tst4 ;   4
sts Digit+2,Temp1 ;  3- 
rjmp Tst24 ;   24

;============================

Tst4:
ldi Temp1,0 ;   
sts Digit+2,Temp1 ;  3- 

lds Temp1,Digit+3 ;  4- 
inc Temp1 ; 4- 
sts Digit+3,Temp1 ;  4- 
rjmp Outpress ;

Tst24:

lds Temp1,Digit+3 ; 4- 
cpi Temp1,2 ; 
brne Outpress ;   

lds Temp1,Digit+2 ; 4- 
cpi Temp1,4 ; 
brne Outpress ;   

ldi Temp1,0
sts Digit+2,Temp1
sts Digit+3,Temp1 ; 3-  4- 

rjmp Outpress ;

Nobut:
ldi Presskey,0 ;   
Outpress:
ret
;**********************************************************
